--Legal Notice: (C)2006 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.standard.all;

entity nes_controller is 
        port (
              -- inputs:
                 signal avs_s1_address : IN STD_LOGIC;
                 signal avs_s1_chipselect : IN STD_LOGIC;
                 signal avs_s1_clk : IN STD_LOGIC;
                 signal avs_s1_read : IN STD_LOGIC;
                 signal avs_s1_reset_n : IN STD_LOGIC;
                 signal avs_s1_write : IN STD_LOGIC;
                 signal avs_s1_writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal data1 : IN STD_LOGIC;
                 signal data2 : IN STD_LOGIC;

              -- outputs:
                 signal avs_s1_readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal latch1 : OUT STD_LOGIC;
                 signal latch2 : OUT STD_LOGIC;
                 signal pulse1 : OUT STD_LOGIC;
                 signal pulse2 : OUT STD_LOGIC
              );
end entity nes_controller;


architecture europa of nes_controller is
component nes_ctlr is 
           port (
                 -- inputs:
                    signal avs_s1_address : IN STD_LOGIC;
                    signal avs_s1_chipselect : IN STD_LOGIC;
                    signal avs_s1_clk : IN STD_LOGIC;
                    signal avs_s1_read : IN STD_LOGIC;
                    signal avs_s1_reset_n : IN STD_LOGIC;
                    signal avs_s1_write : IN STD_LOGIC;
                    signal avs_s1_writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal data1 : IN STD_LOGIC;
                    signal data2 : IN STD_LOGIC;

                 -- outputs:
                    signal avs_s1_readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal latch1 : OUT STD_LOGIC;
                    signal latch2 : OUT STD_LOGIC;
                    signal pulse1 : OUT STD_LOGIC;
                    signal pulse2 : OUT STD_LOGIC
                 );
end component nes_ctlr;

                signal internal_avs_s1_readdata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_latch1 :  STD_LOGIC;
                signal internal_latch2 :  STD_LOGIC;
                signal internal_pulse1 :  STD_LOGIC;
                signal internal_pulse2 :  STD_LOGIC;

begin

  --the_nes_ctlr, which is an e_instance
  the_nes_ctlr : nes_ctlr
    port map(
      avs_s1_readdata => internal_avs_s1_readdata,
      latch1 => internal_latch1,
      latch2 => internal_latch2,
      pulse1 => internal_pulse1,
      pulse2 => internal_pulse2,
      avs_s1_address => avs_s1_address,
      avs_s1_chipselect => avs_s1_chipselect,
      avs_s1_clk => avs_s1_clk,
      avs_s1_read => avs_s1_read,
      avs_s1_reset_n => avs_s1_reset_n,
      avs_s1_write => avs_s1_write,
      avs_s1_writedata => avs_s1_writedata,
      data1 => data1,
      data2 => data2
    );


  --vhdl renameroo for output signals
  avs_s1_readdata <= internal_avs_s1_readdata;
  --vhdl renameroo for output signals
  latch1 <= internal_latch1;
  --vhdl renameroo for output signals
  latch2 <= internal_latch2;
  --vhdl renameroo for output signals
  pulse1 <= internal_pulse1;
  --vhdl renameroo for output signals
  pulse2 <= internal_pulse2;

end europa;

